;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
; *****************************************************************
; *****************************************************************
; ***								***
; ***	               Routines					***
; ***								***
; *****************************************************************
; *****************************************************************


; This sprite-routine was based on Jimmy Mardell's Sprite routine.
; But now this sprite-routine is very different
; and is also based on David Ellsworth's sprite routine (FargoII).
; 
; It is not as fast as Phoenix sprite-routine (~ 7000 Sprites / seconde)
; because I have not the same sprite format (bigger but faster)
; and my screen is 30 bytes long, not 32...
; -maybe in a later release i will change it ...-
;
; It turns at ~ 5500 sprites /seconde. (No Int 1)



; Start sprite routine

 ifeq	SPRITE_R-FAST
; Puts Sprite with Adr=a0.l at D0.w,D1.w
; 	Sprite is a 32 bytes long :  16 Colonnes * 16 Lignes  (/8)
fer3c@0004:
PutSpriteA0:
 movem.l d0-d3/a0-a1,-(a7)
 moveq	#0,d2
 bra.s	PutSpriteEntry

RightShift:
 moveq	#SCREEN_X,d0	; add.l d0,a1 is a few faster than lea SCREEN_X(a1),a1
\RightShift:
 moveq	#0,d2
 move.w	(a0)+,d2
 swap	d2
 lsr.l	d1,d2
 or.l	d2,(a1)
 add.l	d0,a1		; Next row
 dbra.s	d3,\RightShift
 movem.l (a7)+,d0-d3/a0-a1
 rts

QuickPut:
 moveq	#SCREEN_X,d0	; add.l d0,a1 is a few faster than lea SCREEN_X(a1),a1
\QuickPut:
 move.w	(a0)+,d2
 or.w	d2,(a1)
 add.l	d0,a1		; Next row
 dbra.s	d3,\QuickPut
 movem.l (a7)+,d0-d3/a0-a1
 rts
 
; Puts Sprite No D2.w at D0.w,D1.w
; Warning : 0 <= D2 < 1024 !
; Sprite is a 32 bytes long :  16 Colonnes * 16 Lignes  (/8)
PutSprite:
 movem.l d0-d3/a0-a1,-(a7)
 lea     Fernand(PC),a0	; A0 = &Fernand + D2 * 32
 lsl.w   #5,d2		; If you want more than 1024 images,
 adda.w  d2,a0		; you must use d2.l and lsl.l/add.l d2,a0.
PutSpriteEntry:
 moveq	#15,d3		; 16 Rows
 move.l	Screen(a6),a1	; Current screen

 sub.w	Xs(a6),d0		; D0 = (X - X_Scrolling)
 sub.w	Ys(a6),d1		; D1 = (Y - Y_Scrolling)
 cmpi.w	#(SCREEN_Y-16),d1
 bhi.s	ClipVert		; Clipping Vertical
 cmpi.w	#(SC_X*8-16),d0		; Clipping Horizontal
 bhi.s	ClipHor

ClipCenter:		; Pas de cliping horizontal.
 add.w	d1,d1
 move.w	d1,d2
 lsl.w	#4,d2
 sub.w	d1,d2		; D2 = 30 * D1

 move.b	d0,d1		; D1 = x
 lsr.w	#4,d0
 add.w	d0,d0
 add.w	d0,d2		; D2 = 30 * D1 + (D0 / 16) * 2

 adda.w	d2,a1		; A1 = Screen + OffSet

 and.b	#$0F,d1
 beq.s	QuickPut	; Yeah

 cmp.b	#8,d1
 blt.s	RightShift	; Other way

 sub.b	#16,d1
 neg	d1

 moveq	#SCREEN_X,d0	; add.l d0,a1 is a few faster than lea SCREEN_X(a1),a1

\PF_PutRow:
 moveq	#0,d2
 move.w	(a0)+,d2	; D2 = Sprite(Row=D3)
 lsl.l	d1,d2
 or.l	d2,(a1)
 add.l	d0,a1		; Next row
 dbf.s	d3,\PF_PutRow
NoPutSprite:
 movem.l (a7)+,d0-d3/a0-a1
 rts				; Attention : Si changer la pile ici,
				; la changer ailleurs

ClipVert:
 cmpi.w	#(SCREEN_Y-1),d1
 bhi.s	\ClipVert2
 move.w d1,d3
 neg.w	d3
 add.w	#(SCREEN_Y-1),d3	; We will put only (SCREEN_Y -1 - D1) rows
 bra.s	\ClipCentre
\ClipVert2:
 cmpi.w #-16,d1
 ble.s	NoPutSprite
 move.w d1,d3
 bgt.s	NoPutSprite
 addi.w #15,d3		; We will put (15 + y) rows (y <0)
 neg.w	d1
 add.w	d1,d1
; move.w	d1,d2		; Add this line because
 adda.w	d1,a0		
 clr.w	d1		
			; Now D3 = 15 + y, A0 = A0 + 2 * (16- D3), y = 0
\ClipCentre:
 cmpi.w	#(SC_X*8-16+1),d0
 bls.s	ClipCenter

ClipHor:
 cmpi.w #(SC_X*8-16+16),d0
 bcs.s	ClipRight
 bge.s	NoPutSprite
 cmpi.w	#(-16),d0
 ble.s	NoPutSprite
ClipLeft:
 add.w	d1,d1
 move.w  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2

 and.b   #$0F,d0
 sub.b   #16,d0
 neg     d0
 
 adda.w  d2,a1

 moveq	#SCREEN_X,d1	; add.l d0,a1 is a few faster than lea SCREEN_X(a1),a1

\PL_PutRow:
 moveq	 #0,d2
 move.w  (a0)+,d2
 lsl.w   d0,d2
 or.w    d2,(a1)
 add.l	 d1,a1		; Next row
 dbra.s  d3,\PL_PutRow
 movem.l (a7)+,d0-d3/a0-a1
 rts

ClipRight:
 add.w	d1,d1
 move.w  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2

 and.b   #$0F,d0

 lea	(SC_X-2)(a1,d2.w),a1

 moveq	#SCREEN_X,d1	; add.l d0,a1 is a few faster than lea SCREEN_X(a1),a1

\PR_PutRow:
 moveq	#0,d2
 move.w  (a0)+,d2
 lsr.w	 d0,d2
 or.w    d2,(a1)
 add.l	 d1,a1
 dbra.s	 d3,\PR_PutRow
 movem.l (a7)+,d0-d3/a0-a1
 rts				; Exit the sprite routine

 endif
; End Sprite-routine fast.

; Start sprite-routine normal
 ifeq	SPRITE_R-SMALL

; Puts Sprite with Adr=a0.l at D0.w,D1.w
; 	Sprite is a 32 bytes long :  16 Colonnes * 16 Lignes  (/8)
fer3c@0004:
PutSpriteA0:
 movem.l d0-d3/a0-a1,-(a7)
 moveq	#0,d2
 bra.s	PutSpriteEntry

; Puts Sprite No D2.w at D0.w,D1.w
; 	Sprite is a 32 bytes long :  16 Colonnes * 16 Lignes  (/8)
PutSprite:
 movem.l d0-d3/a0-a1,-(a7)
 lea     Fernand(PC),a0	; A0 = &Fernand + D2 * 32
 lsl.w   #5,d2		; If you want more than 1024 images,
 adda.w  d2,a0		; you must use d2.l and lsl.l/add.l d2,a0.
PutSpriteEntry:
 moveq	#15,d3		; 16 Rows

 move.l  Screen(a6),a1	; Current screen

 sub.w  Xs(a6),d0
 sub.w  Ys(a6),d1
 cmpi.w #(SCREEN_Y-16),d1
 bhi.s	ClipVert	; Clipping Vertical
 cmpi.w #(SC_X*8-16),d0		; Clipping Horizontal
 bhi.s	ClipHor

ClipCenter:		; Pas de cliping horizontal.
 lsl.w   #1,d1
 move.w  d1,d2		; Change .l to .w
 lsl.w   #4,d2
 sub.w   d1,d2

 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2

 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1

 adda.w  d2,a1

\PF_PutRow:
 moveq	#0,d2
 move.w	(a0)+,d2
 lsl.l	d1,d2
 or.l	d2,(a1)
 lea	SCREEN_X(a1),a1
 dbra.s	d3,\PF_PutRow
NoPutSprite:
 movem.l (a7)+,d0-d3/a0-a1
 rts

ClipVert:
 cmpi.w	#(SCREEN_Y-1),d1
 bhi.s	\ClipVert2
 move.w d1,d3
 neg.w	d3
 add.w	#(SCREEN_Y-1),d3
 bra.s	\ClipCentre
\ClipVert2:
 cmpi.w #-16,d1
 ble.s	NoPutSprite
 move.w d1,d3
 bgt.s	NoPutSprite
 addi.w #15,d3
 neg.w	d1
 lsl.w	#1,d1
; move.w	d1,d2		; Add this line because
; adda.l	d2,a0		; We don't known anything about d1.l
 adda.w	d1,a0
 clr.w	d1

\ClipCentre:
 cmpi.w	#(SC_X*8-16+1),d0
 bls.s	ClipCenter

ClipHor:
 cmpi.w #(SC_X*8-16+16),d0
 bcs.s	ClipRight
 bge.s	NoPutSprite
 cmpi.w	#(-16),d0
 ble.s	NoPutSprite
ClipLeft:
 lsl.w   #1,d1
 move.w  d1,d2		; Change .l to .w
 lsl.w   #4,d2
 sub.w   d1,d2

 and.b   #$0F,d0
 sub.b   #16,d0
 neg     d0
 
 adda.w  d2,a1

\PL_PutRow:
 moveq	#0,d2
 move.w  (a0)+,d2
 lsl.w   d0,d2
 or.w    d2,(a1)
 lea     SCREEN_X(a1),a1
 dbra.s  d3,\PL_PutRow
 bra.s	NoPutSprite

ClipRight:
 lsl.w   #1,d1
 move.w  d1,d2		; Change .l to .w
 lsl.w   #4,d2
 sub.w   d1,d2

 and.b   #$0F,d0

 lea	(SC_X-2)(a1,d2.w),a1

\PR_PutRow:
 moveq	#0,d2
 move.w  (a0)+,d2
 lsr.w	 d0,d2
 or.w    d2,(a1)
 lea     SCREEN_X(a1),a1
 dbra.s  d3,\PR_PutRow
 bra	 NoPutSprite

 endif
; End Sprite-routine normal










; Put 3 horizontal lines at d0,d1
; Destroy : no register.
fer3c@000C:
PutHor:
 movem.l d0-d2/a0-a1,-(a7)
 sub.w  Ys(a6),d1
 cmpi.w #(SCREEN_Y-3),d1
 bhi.s	NoPutHor

 add.w	d1,d1
 move.w  d1,d2		; Change .w to .l
 lsl.w   #4,d2
 sub.w   d1,d2
 
 move.l  Screen(a6),a1
 adda.w  d2,a1

 moveq	#-1,d2
 moveq	#2,d1
\PutHorLOOP:
 moveq	#(SC_X/4-1),d0
\putLoop:
 move.l d2,(a1)+
 dbra.s	d0,\putLoop
 NEXT_ROW	a1
 dbra.s	d1,\PutHorLOOP
NoPutHor:
 movem.l (a7)+,d0-d2/a0-a1
 rts

; Put 3 vertical lines at d0,d1
; Destroy : no register.
fer3c@000D
PutVer:
 movem.l d0-d2/a0-a1,-(a7)
 sub.w  Xs(a6),d0
 cmpi.w #(SC_X*8-32),d0
 bhi.s	NoPutVer
 
 move.b  d0,d1
 lsr.w	#4,d0
 add.w	d0,d0

 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 
 move.l	Screen(a6),a1
 add.w	d0,a1
 moveq	#$00000007,d2
 lsl.l	d1,d2
 moveq	#(SCREEN_Y-1),d0
 moveq	#SCREEN_X,d1
\putVerLoop:
 or.l	d2,(a1)
 add.l	d1,a1
 dbf.s	d0,\putVerLoop
NoPutVer:
 movem.l (a7)+,d0-d2/a0-a1
 rts

; Clear the LCD screen (Zap_Screen) or the current screeen (ClearScreen)
; Destroy : no register.
Zap_Screen:
 move.l	#LCD_MEM,Screen(a6)
ClearScreen:
 movem.l d0-d1/a1,-(a7)
 move.w	#(SCREEN_SIZE/4-1),d0	; The screen is $F00 bytes = 960 longwords.
 move.l	Screen(a6),a1		; and A1 to the LCD memory
 moveq	#0,d1
\RepClr:
 move.l	d1,(a1)+		; Clear a longword, increase A1 with 4
 dbf.s	d0,\RepClr		; Repeat
 movem.l (a7)+,d0-d1/a1
 rts

; Update the key-buffer.
; Destroy : no register.
; This KeyStat's routine is based on Jimmy Marsden's one :
GetKeyStat:
 movem.l d0-d2/a0-a1,-(a7)
 lea	keystat(PC),a0	; key-Buffer
 lea    $600000,a1	; Set a1 to I/O 
 moveq	#-2,d0		; Mask
 moveq  #Row_Key,d1	; number of rows in the key-matrix
\GetKeys:
 move.w d0,$18(a1)	; mask to read some key
 moveq	#WAIT_FOR_KEY,d2
\Wait:			; Wait until the hardware answer.
 dbf.s	d2,\Wait
 move.b	$1B(a1),(a0)+	; Read the key pressed
 rol.w	#1,d0		; Update mask
 dbf.s	d1,\GetKeys	; Next key
 movem.l (a7)+,d0-d2/a0-a1
 rts

; Lecture dans la table des tests en d0 -> x , d1 -> y
; D2 = TestTable[D0,D1]
; Return  D2
; Destroy a0
Lecture:
 move.l LevelTestADR(a6),a0
QLecture:
 movem.l d0-d1,-(a7)
 lsr.w  #5,d0
 and.w	#(-(32-1)-1),d1	; Taille niveau X = 128 = 2^7
 lsl.w	#(7-5),d1
 add.w  d0,d1
 move.b 0(a0,d1.w),d2
 movem.l (a7)+,d0-d1
 rts

; Is the sprite on a block ? Sprite = 15 x 15 pixels.
; Entry :	d0.w = X
;		d1.w = Y
; Destroy d2 & a0
fer3c@0005:
GetTest:	; Teste si le perso en D0,D1 est sur un bloc
		; Retourne D2 = 0 (Pas pos), AUTRE sinon
 movem.l d0-d1/d3-d4,-(a7)
 moveq	#0,d2
 moveq	#15,d3
 moveq	#1,d4
 bsr	Lecture
 cmp.b	d4,d2
 beq.s	\TestFaux
 add.w	d3,d0
 bsr	QLecture
 cmp.b	d4,d2
 beq.s	\TestFaux
 add.w	d3,d1
 bsr	QLecture
 cmp.b	d4,d2
 beq.s	\TestFaux
 sub.w	d3,d0
 bsr	QLecture
\TestFaux:
 movem.l (a7)+,d0-d1/d3-d4
 subq.b #1,d2
 rts

; Affiche le statut du personnage
; Write the stat bar
; Destroy all registers !
Statut:
 lea	LCD_MEM,a1
 moveq  #(SCREEN_Y-1),d2
 lea	STAT_X(a1),a1
 moveq	#-1,d4
\Loop:
 move.l d4,(a1)+
 move.w d4,(a1)+
 lea	(SCREEN_X-6)(a1),a1
 dbra.s	d2,\Loop
 
 lea	Statut_Text(PC),a3
 moveq	#3,d7
 bsr	DrawTextWithoutClear

 SetFont	NORMAL

 bsr.s	PutPower
 bsr.s	PutLife
 bsr.s	PutKey

 tst.b	BoutON(a6)
 bne.s	PutON
PutOFF:
 WriteStr #NUMBER_X,#(STAT_Y4+11),#4,OFF_Str
 bra	CopyTo2ndScreen

PutON:
 WriteStr #NUMBER_X,#(STAT_Y4+11),#4,ON_Str
 bra.s	CopyTo2ndScreen

PutPower:
 move.w	Bj(a6),d3
 moveq	#(STAT_Y1+11),d2
 bra.s	PutNumber

PutLife:
 move.w	Vi(a6),d3
 moveq	#(STAT_Y2+11),d2
 bra.s	PutNumber

PutKey:
 move.w	Cf(a6),d3
 moveq	#(STAT_Y3+11),d2

; Put the number d3.l at coordinates ( #NUMBER_X, d2.w)
; Destroy : no registers

PutNumber:
 cmp.w	#99999,d3
 bhi.s	Stat1		; Skip if the number is too hight !

 movem.l d0-d3/a0-a1,-(a7)

 lea    strend(a6),a0	; Load tempory storage string adress
 moveq  #6,d1		; 7 digits
 clr.b  (a0)		; for DrawStrXY
\Rep1:
 divu   #10,d3		; d3 / 10
 swap   d3		; Work on the rest
 addi.b #'0',d3		; Add 48 to the rest of the division
 move.b d3,-(a0)	; Save the rest
 subq   #1,d1		
 clr.w	d3		; Clear the rest
 swap	d3		; New number D3.l = Int(D3.l / 10)
 bne.s	\Rep1		; No need of 'tst' because 'swap' does it
 tst.w  d1
 beq.s	\CSDone
 subq   #1,d1		; For dbf
\Rep2:
 move.b #' ',-(a0)	; Complete par des espaces
 dbra.s	d1,\Rep2
\CSDone:

 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  d2,-(a7)
 move.w  #NUMBER_X,-(a7)
 jsr 	 tios::DrawStrXY	; ?
 lea     10(a7),a7

 movem.l (a7)+,d0-d3/a0-a1
Stat1:
 rts

; Copy Stat from LCD_MEM to 2nd Screen
; Destroy : a0 / a1 / d2 / d3 (!)
CopyTo2ndScreen:
SecondScreenIV:
 move.l	#0,a0			; Source : Immediate Value
				; Program will write here...
 lea	LCD_MEM,a1		; destination

 moveq  #(SCREEN_Y-1),d2	; Numbers of rows
 moveq	#(STAT_X),d3
 adda.l	d3,a0
 adda.l	d3,a1
 moveq	#(SCREEN_X-6),d3
\Loop:
 move.l (a1)+,(a0)+
 move.w (a1)+,(a0)+
 adda.l	d3,a0
 adda.l	d3,a1
 dbra.s	d2,\Loop
 rts

; Decrease fernando's power and kill him if power=0.
fer3c@0008:
Touche:
	move.w	v(a6),d2
	bne.s	\PicSort	; In copyto2ndscreen routine
	bsr.s	FlashScreen
	move.w	Bj(a6),d2
	beq.s	\PicMort
	sub.w	Diff(a6),d2
	bge.s	\PicFin
	clr.w	d2
	bra.s	\PicFin
\PicMort:
	clr.b	Mort(a6)	; You die !
\PicFin:
	move.w	d2,Bj(a6)
	move.w	Diff2(a6),v(a6)	; Dure
	bsr	PutPower
	bra.s	CopyTo2ndScreen
\PicSort:
	rts

; Collision entre (d0,d1) et (d6,d7) TailleX = TailleY = 16
; Renvoie D2=0, Aucune collision
;	  D2=1, (d0,d1) & (d6,d7)
fer3c@0006:
TestCollision:
	move.w	d6,d2
	sub.w	d0,d2
	bge.s	\invt
	neg.w	d2
\invt:	cmp.w	#15,d2
	bgt.s	NoTuch

	move.w	d7,d2
	sub.w	d1,d2
	bge.s	\invt2
	neg.w	d2
\invt2:	cmp.w	#15,d2
	bgt.s	NoTuch

	moveq	#0,D2
	rts
NoTuch:
	moveq	#1,D2
	rts

; Test Sprite exit of the screen (d0,d1)
; Renvoie D2=0, No exit
;	  D2=1 Sprite exit
fer3c@0007:
TestExitScreen:
	move.w	Xs(a6),d2
	subi.w	#(31*2),d2
	cmp.w	d2,d0
	blt.s	\Exit
	addi.w	#(31*(1+2+1)+32+SC_X*8),d2
	cmp.w	d2,d0
	bgt.s	\Exit
	move.w	Ys(a6),d2
	subi.w	#(31*2),d2
	cmp.w	d2,d1
	blt.s	\Exit
	addi.w	#(31*(1+2+2)+SCREEN_Y+32),d2
	cmp.w	d2,d1
	bgt.s	\Exit
	moveq	#1,d2
	rts
\Exit:
	moveq	#0,D2
	rts

FlashScreen:
 movem.l d0-d1/a0,-(a7)
 moveq	#63,d1
\RepInverseScr:
 move.w	#(SCREEN_SIZE/4-1),d0
 move.l	Screen(a6),a0
\RepInv:
 not.l	(a0)+
 dbf.s	d0,\RepInv
 bsr	ChangeScreen
 dbf.s	d1,\RepInverseScr
 movem.l (a7)+,d0-d1/a0
 rts

fer3c@0003:
; a5.l -> Sprite, d0.l = Size of the sprite
; Destroy a0,a1,d0 and d1
DestroySprite:
	move.l	a5,a0		; Source
	move.l	a5,a1
	add.l	d0,a1		; Destination
	move.l	SpriteADREnd(a6),d1	; Get spriteADREnd
	sub.l	a1,d1		; Get number of bytes to move
	lsr.w	#2,d1		; Get number of double words to move
				; It is on one word
	sub.l  d0,SpriteADREnd(a6)	; Correct the new value of SriteADREnd
\DelBoucle:
	move.l	(a1)+,(a0)+
	dbf.s	d1,\DelBoucle
	rts

; Wait while a key is pressed
; Destroy : a0 / d0
WaitForNotKey:
	lea	$600000,a0		; Set a0 to I/O for direct prot access
	clr.l	($18)(a0)		; Mask to read keys
\Wait:	move.b	$1B(a0),d0		; Wait for all keys
	cmpi.b	#$FF,d0
	bne.s	\Wait
	rts

WaitForAllKey:
	bsr	WaitForNotKey
\Loop	move.b	$1B(a0),d0		; Wait for all keys
	cmpi.b	#$FF,d0
	beq.s	\Loop
	rts

; a3 -> Structure and d7 = Numbers
; Destroy a0-a3 / d0-d2 and d7
fer3c@000B:
DrawText:
	bsr	Zap_Screen
DrawTextWithoutClear:
\Loop:
	move.w	(a3)+,-(a7)
	jsr	tios::FontSetSys
	move.w	#4,-(a7)
	movem.w	(a3)+,d0-d1
	move.l	(a3)+,-(a7)
	movem.w	d1-d0,-(a7)
	jsr     tios::DrawStrXY
	lea	12(a7),a7
	dbf.s	d7,\Loop
	rts

ClearTab:
	lsr.w	#5,d0
	and.w	#(-(32-1)-1),d1 ; Taille niveau X = 128 = 2^7
	lsl.w	#(7-5),d1
	add.w	d0,d1
	move.l	LevelTestADR(a6),a0
	clr.b	0(a0,d1.w)
	rts

GetKey:
	clr.w	KEY_PRESSED_FLAG
\loop:		tst.w	KEY_PRESSED_FLAG
		beq.s	\loop
	move.w	GETKEY_CODE,d0
	rts
