;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;
; *****************************************************************
; ***								***
; ***	         	Extended Sprites			***
; ***								***
; *****************************************************************
; *****************************************************************


Sprite_Pow:
	subq.w	#1,POW_TMP(a5)		; Destroy the sprite after a while
	bne.s	\No
	moveq	#POW_END,d0
	bra	DestroySprite
\No:	move.w	Xj(a5),d0
	move.w	Yj(a5),d1		; Set xj, yj
	move.w	POW_A(a5),d2
	addq.w	#1,d2
	and.w	#%011111,d2
	move.w	d2,POW_A(a5)		; Calculate the image
	lsr.w	#4,d2
	add.w	#POWER_DIS,d2		; d2 = image
	bsr	PutSprite		; Draw the image
	lea	POW_END(a5),a5		; Next sprite
	rts

Sprite_Spider:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	SPIDER_V(a5),d4
	move.w	SPIDER_ACT(a5),d2
	bne.s	\Tombe	; Calculate the new position
	add.w	d4,d0
	bsr	GetTest
	beq.s	\SetT	; A block => fall
	move.w	d6,d3	; Calcul if it now falls
	sub.w	d0,d3
	eor.w	d4,d3
	moveq	#SPIDER_WALK,d2
	and.w	#%1000000000000000,d3	; If (X_fer-Xj) * Speed_X < 0, then fall
	beq.s	\Then
\SetT:	st	SPIDER_ACT(a5)	; Set now fall
\Tombe:	moveq	#SPIDER_FALL,d2
	add.w	Turbo(a6),d1
\Then:	move.w	d0,Xj(a5)
	move.w	d1,Yj(a5)
	move.w	POW_A(a5),d3	; Calculate the image
	addq.w	#1,d3
	and.w	#%011111,d3
	move.w	d3,POW_A(a5)
	lsr.w	#4,d3
	add.w	d3,d2
	bsr	PutSprite
	moveq	#SPIDER_END,d3
	moveq	#91,d4
	bsr	SpriteTest
	lea	SPIDER_END(a5),a5
	rts

Sprite_Ber:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	BER_TMP(a5),d2
	beq.s	\NoFiring
	subq.w	#1,d2
	move.w	d2,BER_TMP(a5)
	moveq	#BER_FIRE,d2
	add.w	BER_FS(a5),d2
	bra.s	\Hello	; Print it.
\NoFiring:
	move.w	d0,d2
	sub.w	d6,d2
	move.w	d2,d3
	bgt.s	\NoAbs
	neg.w	d2		; Abs(Xj - Xfer)
\NoAbs:	cmp.w	#BER_DIST,d2	; Fire ?
	bgt.s	\No2
	move.w	#BER_TIME,BER_TMP(a5)	; Set fire
	moveq	#15,d4		; Because of lsr
	lsr.w	d4,d3		; lsr...
	moveq	#-1,d4		; Speedx of laser
	move.w	d3,BER_FS(a5)	; Direction
	beq.s	\NoExc
	moveq	#1,d4	; Speed X
\NoExc:	move.w	d1,d2	; Y
	move.w	d0,d1	; X
	moveq	#0,d5	; SpeedY
	moveq	#4,d0	; Laser
	bsr	SpriteInit	; Init it !
	move.w	d1,d0
	move.w	d2,d1	; restore x & y
\No2:	move.w	BER_A(a5),d2	; Calculate the image
	addq.w	#1,d2
	and.w	#%01111111,d2
	move.w	d2,BER_A(a5)
	lsr.w	#4,d2
	move.w	d2,d3
	and.w	#%11,d2
	and.w	#%100,d3	; Reverse animation ?
	beq.s	\No3
	eor.w	#%11,d2	; Reverse
\No3:	add.w	#BER,d2
\Hello:	bsr	PutSprite
	moveq	#BER_END,d3
	moveq	#92,d4
	bsr	SpriteTest
	lea	BER_END(a5),a5
	rts

Sprite_Butter_Fly:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	d6,d2
	move.w	d7,d3
	add.w	DEST_X(a5),d2
	add.w	DEST_Y(a5),d3	; Set registers
	move.w	Turbo(a6),d4
	add.w	d4,d0
	add.w	d4,d1
	add.w	d4,d4		; Calculate new position
	cmp.w	d0,d2
	bgt.s	\C1
	sub.w	d4,d0
\C1:	cmp.w	d1,d3
	bgt.s	\C2
	sub.w	d4,d1		; Correct new if needed.
\C2:	move.w	d0,Xj(a5)	; Save new values.
	move.w	d1,Yj(a5)
	subq.w	#1,BUT_TMP(a5)
	bne.s	\NoNew
	move.w	#25,BUT_TMP(a5)
	move.w	DEST_X(a5),d2
	neg.w	d2
	addq.w	#1,d2
	move.w	d2,DEST_X(a5)	; Calculate new DecaX
	move.w	DEST_Y(a5),d2
	neg.w	d2
	addq.w	#1,d2
	move.w	d2,DEST_Y(a5)	; Calculate new DecaY
\NoNew:	moveq	#BUTTER_FLY,d2
	cmp.w	d0,d6
	bls.s	\Ok
	addq.w	#1,d2		; Calculate Image
\Ok:	bsr	PutSprite	; ?
	moveq	#BUT_END,d3
	moveq	#93,d4
	bsr	SpriteTest	; Test all need
	lea	BUT_END(a5),a5	; Next sprite
	rts	

Sprite_PacMan:
	move.w	Xj(a5),d0
	add.w	Turbo(a6),d0
	cmp.w	#4096,d0
	bls.s	\Ouf
	moveq	#PAC_END,d0
	bra	DestroySprite
\Ouf:	move.w	d0,Xj(a5)
	move.w	Yj(a5),d1
	moveq	#16,d3		; For fast
	moveq	#PACMAN_1,d2
	bsr	PutSprite	; Put one
	add.w	d3,d1
	moveq	#PACMAN_4,d2
	bsr	PutSprite
	move.w	PAC_A(a5),d2	; Calculate the image
	addq.w	#1,d2
	and.w	#%011111,d2
	move.w	d2,PAC_A(a5)
	and.w	#%010000,d2
	beq.s	\One
	add.w	d3,d0
	moveq	#PACMAN_3,d2
	bsr	PutSprite
	sub.w	d3,d1
	moveq	#PACMAN_2,d2
	bsr	PutSprite
	bra.s	\Next
\One:	add.w	d3,d0
	move.w	#PACMAN_33,d2
	bsr	PutSprite
	sub.w	d3,d1
	move.w	#PACMAN_22,d2
	bsr	PutSprite
\Next:	bsr	ClearTab	; Clear test
	move.l	LevelADR(a6),a0	; Clear graph
	clr.b	0(a0,d1.w)
	move.w	Time(a6),d0
	and.w	#31,d0
	bne.s	\No
	move.w	#4000,YsOld(a6)
\No:	lea	PAC_END(a5),a5
	rts

Sprite_Boum:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	add.w	Turbo(a6),d1
	move.w	d1,Yj(a5)
	bsr	TestExitScreen
	beq.s	\Destroy
	bsr	TestCollision
	beq.s	\Collision
	bsr	GetTest
	bne.s	\NoCollision
\Collision:
	move.w	d1,d2	;y
	move.w	d0,d1	;x
	lea	\Boum_Table(PC),a2
	moveq	#8-1,d3
\loop:	move.w	(a2)+,d4	; load Speed x
	move.w	(a2)+,d5	; load Speed y
	moveq	#4,d0		; Laser
	bsr	SpriteInit	; init
	dbf	d3,\loop
\Destroy:
	moveq	#BOUM_END,d0
	bra	DestroySprite
\Boum_Table:
	dc.w	2,2,2,-2,-2,-2,-2,2
	dc.w	1,1,1,-1,-1,-1,-1,1
\NoCollision:
	moveq	#-1,d2
	move.w	#BOUM,d2
	bsr	PutSprite
	addq.l	#BOUM_END,a5
	rts

Sprite_Plane:
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	PLANE_SENS(a5),d3
	moveq	#16,d4		; Faster
	add.w	d3,d0
	move.w	d0,a2
	bsr	GetTest
	beq.s	\Do
	add.w	d4,d0
	bsr	GetTest
	bne.s	\No
\Do:	neg.w	d3
\No:	move.w	a2,d0	; Restore Xj
	move.w	d0,Xj(a5)
	move.w	#PLANE,d2
	move.w	d3,PLANE_SENS(a5)
	tst.w	d3
	bgt.s	\AllRight
	addq.w	#2,d2
\AllRight:
	bsr	PutSprite
	add.w	d4,d0
	addq.w	#1,d2
	bsr	PutSprite
; Boum ?
	subq.w	#1,PLANE_TMP(a5)
	bgt.s	\Nothing
	move.w	#45,PLANE_TMP(a5)
	move.w	d1,d2
	move.w	d0,d1
	move.w	#SpriteSkip+126,d0
	bsr	SpriteInit
	move.w	d1,d0
	move.w	d2,d1
\Nothing:
	moveq	#PLANE_END,d3
	moveq	#97,d4
	bsr	SpriteTest
	lea	PLANE_END(a5),a5
	rts

Sprite_Nibbles:

; Calculate new coordinates
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	move.w	d6,d2
	move.w	d7,d3
	add.w	DEST_X(a5),d2
	add.w	DEST_Y(a5),d3	; Set registers
	move.w	Turbo(a6),d4
	add.w	d4,d0
	add.w	d4,d1
	add.w	d4,d4		; Calculate new position
	cmp.w	d0,d2
	bgt.s	\C1
	sub.w	d4,d0
\C1:	cmp.w	d1,d3
	bgt.s	\C2
	sub.w	d4,d1		; Correct new if needed.
\C2:	

; Change direction
	subq.w	#1,BUT_TMP(a5)
	bne.s	\NoNew
	move.w	#40,BUT_TMP(a5)
	lea	Nibbles_Table(PC),a0
	move.w	NIB_D(a5),d2
	addq.w	#2,d2
	and.w	#%11110,d2
	move.w	d2,NIB_D(a5)
	move.b	0(a0,d2.w),d3
	ext.w	d3
	move.w	d3,DEST_X(a5)
	move.b	1(a0,d2.w),d3
	ext.w	d3
	move.w	d3,DEST_Y(a5)
\NoNew:	

; Save coordinates
	lea	NIB_TABLE(a5),a2	; Adress of table
	lea	NIB_END(a5),a0		; For dbf
	move.w	Time(a6),d3
	and.w	#7,d3			; Refresh table ?
	bne.s	\SaveXYj
	lea	-4(a0),a1		; For dbf
	moveq	#SIZE_NIBBLES-2,d3	; Size of the Table - 2
\Loop_Save:
	move.l	-(a1),-(a0)		; Translate table
	dbf	d3,\Loop_Save
	move.w	Xj(a5),(a2)		; Save (Xj,Yj)) -> Table[0]
	move.w	Yj(a5),2(a2)
\SaveXYj:
	move.w	d0,Xj(a5)		; (d0, d1) -> (xj, yj)
	move.w	d1,Yj(a5)

; Test exit screen
	bsr	TestExitScreen
	bne.s	\No_Exit_Screen
	move.l  LevelTestADR(a6),a0
	move.w  Adresse(a5),d0
	move.b  #94,0(a0,d0.w)
	moveq	#NIB_END,d0
	bra	DestroySprite
\No_Exit_Screen:

; Test collision
	movem.w	d0-d1,-(a7)	; Save Xj ,and yj
	moveq	#SIZE_NIBBLES,d3	; D3 = Number of loop
	move.l	a2,a0		; a0 = &Nib_Table
\Loop_Coll:
	bsr	TestCollision	; Now test collision...
	bne.s	\No_Coll
	cmp.w	d1,d7
	bge.s	\NoDestroy
	move.l	SpriteADR(a6),a0 ; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d2	 ; de la liste pile
	move.w  d2,F_St(a0)
	move.w  #10,F_Action(a0)
	subq.w	#1,FORCE(a5)
	bne.s	\End_Loop
	addq.l	#4,a7		; Skip d0,d1.w saved on the stack
	moveq	#NIB_END,d3
	bra	Destroy
\NoDestroy
	bsr	Touche
	bra.s	\End_Loop
\No_Coll:
	move.w	(a0)+,d0
	move.w	(a0)+,d1	; Read next xj and yj
	dbf.s	d3,\Loop_Coll
\End_Loop:
	movem.w	(a7)+,d0-d1	; Restore Xj, Yj

; Calculate animation
	move.w	NIB_A(a5),d4
	addq.w	#1,d4
	and.w	#%1111,d4
	move.w	d4,NIB_A(a5)
	lsr.w	#3,d4

; Draw 
	moveq	#SIZE_NIBBLES,d3
\Loop_Put:
	moveq	#NIBBLES,d2
	add.w	d4,d2
	eori.w	#1,d4
	bsr	PutSprite
	move.w	(a2)+,d0
	move.w	(a2)+,d1
	dbf	d3,\Loop_Put

; End of sprite / Correct sprite table / return
	lea	NIB_END(a5),a5
	rts

Nibbles_Table:
	dc.b	60,0,46,36,-30,36,-60,0
	dc.b	-30,-20,46,-25,80,0,-10,60
	dc.b	-60,-10,30,-30,-60,-10,10,50
	dc.b	0,40,-20,10,20,-10,0,-10

