; This file is an example of AddOn for Fer3c
; It is very badly coded but I think it's better to understand...
; By Plissier Patrick (26/03/99)

; Include the header files
	include "tios.h"
	include "flib.h"
	include	"fer3c.h"
	include "sprite.h"

; You need it to restore the sprite.
NUMBER		EQU	78	; No of the sprite in Level-File

; Your data structure

;No		EQU	0	; No of the sprite : 2*SpriteInitStart+72
;Xj		EQU	2	; X coordinate
;Yj		EQU	4	; Y coordinate
;Adress		EQU	6	; Adress of the Starting-point if Level-File
Gfx		EQU	8
Aux_Vx		EQU	10	; Speed x
Aux_A		EQU	12	; for animation
Aux_End		EQU	14	; The end of the buffer for this sprite




; SpriteInit
; This routine will be called each time a new sprite 'AddOn' / 'plugin'
; must be initialized

; a0 -> The max of the sprite-buffer.
; a1 -> The end of the current sprite-buffer
; d0.w = Number of the current sprite (here AddOn)
; d1.w = StartX
; d2.w = StartY
; d3.w = Relative adress in table, the sprite has been called from Table[d3.w]
;	he needs to be restored before quitting

SpriteInit:	; Entry Point
; we must add this sprite to the sprite-buffer.
; First, we must test if there is enought memory left
 lea	-Aux_End(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi	Skip1		; No exit
			; REM : if you need less than 200 bytes, you can
			; not test memory !
; Ok we can add it.
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NOT CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	#1,Aux_Vx(a1)	; We will go to the right : SpeedX = 1

; We have add it. Now we correct the spriteBuffer
 lea Aux_End(a1),a1	; New SpriteEndADR
Skip1:
 rts			; Exit

; This routine is called each frame.
; It must move the sprite,
; test the collision with Fernando,
; test if the sprite is outside the screen and
; print the sprite on the screen.
SpriteExec:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	addq.w	#1,d1		; Y = Y + 1
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Escape		; No
	move.w	d1,Yj(a5)	; Yes, save the Y coordinate
\Escape:
	move.w	fer3c::Time,d0	; We take the current time
	andi.w	#63,d0		; In order to syncronize...
	beq	\Conti		; if 64 frame has passed, change the speed direction
	move.w  Xj(a5),d0	; d0 = X coordinate
	move.w  Yj(a5),d1	; d1 = Y coordinate
	add.w   Aux_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra	\Conti2
\Conti:	
	neg.w	Aux_Vx(a5)	; The sprite can't go here : Speedx = -Speedx
\Conti2:
	move.w  Xj(a5),d0	; D0= X
	move.w  Yj(a5),d1	; d1 = y
	jsr	fer3c::TestCollision	; Test between the sprite and Fernando ?
	bne	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt	Destroy		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; No we hurt Fernando
\No:	
	jsr	fer3c::TestExitScreen	; Test if the sprite is outside the screen
	bne	Next			; The sprite is near the screen.
	move.l  fer3c::LevelTestADR,a0	; Get adress of the table
	move.w  Adress(a5),d0		; Get initial position in table
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	moveq	#Aux_End,d0		; Size of the sprite
	jmp	fer3c::DestroySprite	; Destroy the sprite and quit.
Destroy:
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init sprite : explosion 1
	move.l  fer3c::SpriteADR,a0	; Get the beginining of the buffer
					; Fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it in F_St
	move.w  #10,F_Action(a0)	; Init Jump2
	move.l  #Aux_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
Next:
	moveq	#0,d2		; because we need the upper 16 bits od d2 set to 0
	move.w  Aux_A(a5),d2	; Get Aux_A
	addq.w  #1,d2		; Aux_A +1
	andi.w  #63,d2		; (Aux + 1 ) mod 64
	move.w  d2,Aux_A(a5)	; Aux_A = (Aux_A + 1) mod 64
	andi.w  #48,d2		; d2 = Aux_A and 48
	lsr.w   #4,d2		; D2 = Int ( Aux_A / 16)
	lsl.w	#5,d2		; 32 * D2 (a Gfx is 32 bytes long)
	lea	Graphic(PC),a0	; a0 = adress of the graphics
	add.l   d2,a0		; A0 = Adress of the gfx of the sprite
	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	jsr	fer3c::PutSprite	; put the sprite
	lea	Aux_End(a5),a5	; Next Sprite in buffer
	rts			; Return

Graphic:	INCBIN	"enm1.s16"
		; Include the graph of the sprite

; You don't need _main, _comment, end because it will be added to the world
; thanks to MkWorld. (This file is an INCLUDE file).
