;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***            F E R N A N D O   3-C 	TI-ASM 68000 Version		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;
;****************************************************************************
;****************************************************************************
;
;				LINK GESTION
;
;****************************************************************************
;****************************************************************************


; Add an offset to the offset table to be sent, and delete T[offset]
; at the other calc
; d1.w = offset
Add_To_Send:
	movem.l d0/a0,-(a7)
	lea	offset_table(a6),a0
	move.w	(a0),d0		; read current position in table
	move.w	d1,4(a0,d0.w)	; Save in table
	addq.w	#2,d0		; position ++
	and.w	#%01110,d0	; Next position
	move.w	d0,(a0)		; Save the new position
	move.w	#$FFFF,4(a0,d0.w)	; Set the next to $FFFF : stop flag.
	movem.l (a7)+,d0/a0
	rts

; C'est le sprite qui va grer les collisions, les effacements de donnes,
; l'affichage, la rception et l'envoie entre les deux calcs relies par link.
; Bref il s'occupe du link, mais c'est l'interruption qui se charge du reste !
Sprite_Link_Gestion:
; Can we send a new buffer ?
	move.w	BufferS(a6),d2		; Has been sent ?
	bne	\NoSent			; BufferS = 0 => Tout a t envoy
	move.w	BufferR(a6),d2		; Receive ?
	beq	\NoSent			; BufferR = 0 => En cours de recetion
; Ok. We can cook the next send-buffer.
	move.l	SpriteADR(a6),a0	; Load adress
	lea	BufferS(a6),a1

	moveq	#0,d0
	moveq	#(32-12),d1
	move.w	Xj(a0),d0		; 12 bits fo x position
	lsl.l	d1,d0
	moveq	#0,d2
	moveq	#(20-10),d1
	move.w	Yj(a0),d2		; 10 bits for y position
	lsl.l	d1,d2
	or.l	d2,d0			; X and Y position are in d0

	move.w	Dessin(a0),d2
	add.w	F_Sens(a0),d2		; Only 1 byte
	or.b	d2,d0			; Draw
	move.l	d0,4(a1)		; Save in send-buffer

	lea	offset_table(a6),a0
	move.w	2(a0),d0	; Get the no of the current offset to send
	move.w	4(a0,d0.w),d1	; Get the offset to send
	blt.s	\NoAdd		; <0 so it is $FFFF : stop flag
	addq.w	#2,d0		; position ++
	and.w	#%01110,d0	; Next position
\NoAdd:
	move.w	d1,8(a1)	; Save in send-buffer. Next time, I will optimize it.
	move.w	d0,2(a0)	; Save new value of the no of the offset

	move.l	BufferR+4(a6),RC_Data(a6) ; Copy receive-buffer -> used-buffer

	move.w	BufferR+8(a6),d0	; Read offset
	blt.s	\NoDel		; It is <0 so it isn't an offset but a stop flag ($FFFF)
	move.l	LevelTestADR(a6),a0
	clr.b	0(a0,d0.w)	; Clear the offset; the item has been taken
				; by the other player : test table
	move.l	LevelADR(a6),a0
	clr.b	0(a0,d0.w)	; Clear the offset; the item has been taken
				; by the other player : graph table
	move.w	#4000,YsOld(a6)	; Refresh virtual screen
\NoDel:
	clr.w	BufferR(a6)	; Ok, we have recieve. Clear the receive-flag.
	move.w	#1,BufferS(a6)	; We have to send something. Set the send-flag
	btst	#1,($60000C)	; Well if it is <> of 1, skip else set to 1;
	bne.s	\NoSent
	bset	#1,($60000C)	; Init Int 4
\NoSent:
	moveq	#0,d2		; Draw Fernando at curent position
	move.l	RC_Data(a6),d0
	move.b	d0,d2		; Number of the draw
	
	move.l	d0,d1
	moveq	#(32-12),d3
	lsr.l	d3,d0		; X position
	
	and.l	#$000FFC00,d1
	moveq	#(20-10),d3
	lsr.l	d3,d1		; Y position

	bsr	PutSprite	; Draw fernando

; Test collision with the Fernando of the other calc.
	bsr	TestCollision
	bne.s	\NoCollision
	cmp.w	d1,d7
	bge.s	\NoCollision
; Jump this Fernando. Doesn't work very well.
	move.l	SpriteADR(a6),a0 ; ATTENTION : Fernando doit tre le premier
	move.w  F_Haut(a0),d0	 ; de la liste pile
	move.w  d0,F_St(a0)
	move.w  #10,F_Action(a0)
\NoCollision:

; Global changes in Level Test table
	lea	Link_Gestion_End(a5),a5	; Next sprite
	rts












Link_mode:
; On se rappelle l'adresse du monde : World adress
	move.l	LevelADR(a6),a5
	move.l	a5,-(a7)

; On lit le nombre de niveau dans d7 : Numbers of levels
	move.w	(a5)+,d5

; On initialise Level  1 : dans d6  : Level 1
	moveq	#1,d6

; Score : 0-0
	clr.l	Score(a6)

Link_Start_Level:
	lea	Competition_Text(PC),a3
	moveq	#3,d7
	bsr	DrawText

	move.l	d6,d3
	moveq	#LEVEL2_Y,d2
	bsr	PutNumber	; Put the current level on the screen

	move.w	Score(a6),d3
	moveq	#LEVEL3_Y,d2
	bsr	PutNumber	; Put your score
	move.w	(Score+2)(a6),d3
	moveq	#LEVEL4_Y,d2
	bsr	PutNumber	; Put his score
	
	bsr	GetKey		; Read one key

	cmp.w	#264,d0
	beq	Link_Exit
	cmp.w	#KEY_LEFT,d0
	bne.s	\NoR
	cmp.w	#1,d6
	ble.s	Link_Start_Level
	subq.w	#1,d6
\NoR:
	cmp.w	#KEY_RIGHT,d0
	bne.s	\NoL
	cmp.w	d5,d6
	bge.s	Link_Start_Level
	addq.w	#1,d6
\NoL:
	cmp.w	#13,d0
	bne.s	Link_Start_Level

; Clear the tables
	lea	LinkDataStart(a6),a0
	moveq	#(LinkDataEnd-LinkDataStart-1),d0
\Clear_Loop
	clr.b	(a0)+
	dbf.s	d0,\Clear_Loop

; Set some data about buffer
	st	BufferR(a6)	; Buffer Receive = nothing
	st	Link(a6)	; Link mode = true
	move.w	#$FFFF,offset_table+4(a6)

; Set I/O data
	bsr	Zap_Screen
	jsr	tios::reset_link

; Synchro
	WriteStr #1,#1,#4,Link_Str
	bsr	Synchro
	bne	Link_Start_Level

; Redirige Int #4, #5 and #6
	lea	$600000,a0	; Set a0 to I/O for direct prot access
	move.w #$0700,d0
	trap   #1		; Set all int off
	move.l $70,OldInt4(a6)	; Save old Int #4
	move.l $74,OldInt5(a6)	; Save old int #5
	move.l $78,OldInt6(a6)	; Save old int #6
	bclr.b #2,$1(a0)	; We can write in low memory !
	move.l #NewInt4,$70	; New int #4
	move.l #NewInt5,$74	; New int #5
	move.l #NewInt6,$78	; New int #6
	bset.b #2,$1(a0)	; Restore the low memory Int
	move.w	#$300,d0	; Disable auto int #1, #2 and #3
	trap   #1		; Restore all int 

; Extraction du niveau
	move.w	d6,d0	; File d0
	move.l	a5,a0	; Adr a0
	jsr	pk92lib::Extract
	tst.b	d0	; Ok ?
	bne.s	\ExitPk

	move.b #LEVEL_COMPLETED,Mort(a6)	; Level completed (if not, it will change)

; Save the handle on the stack in order to be deleted before quitting
	move.w d1,-(a7)

; The adresse is in a1 and the handle in D1.
	move.l SpriteADR(a6),SpriteADREnd(a6)	; ReInit Sprite Table
	movem.l d0-d7/a0-a6,-(a7)
	tst.w	(a1)+			; Test the type of the level 
	bne.s	\Skip			; Not a plat-form level, skip
	bsr	BeginLevel
	bra.s	\Ok
\Skip:
	move.b	#NOT_A_LEVEL,Mort(a6)
\Ok:
	movem.l (a7)+,d0-d7/a0-a6
\Escape:

; Destroy the handle of the level file
	jsr	tios::HeapFree
	addq.l	#2,a7
 
\ExitPk:
; Redirige Auto-Int #4,#5 and #6
	lea	$600000,a0	; Set a0 to I/O for direct prot access
	move.w #$0700,d0
	trap   #1		; Set all int off
	bclr.b #2,$1(a0)	; We can write in low memory !
	move.l OldInt4(a6),$70	; Restore old int
	move.l OldInt5(a6),$74
	move.l OldInt6(a6),$78
	bset.b #2,$1(a0)	; Restore the low memory Int
	moveq	#0,d0
	trap   #1		; Restore all int 
	jsr	tios::reset_link
	
; Now update scores !
	cmp.b	#LEVEL_COMPLETED,Mort(a6)
	bne	Link_Start_Level

	bsr	Zap_Screen
	WriteStr #1,#1,#4,Pass_Str
	moveq	#LINK_BYTE,d0
	bsr	SendByte
	
	moveq	#-1,d0
\l2:	dbf	d0,\l2	; Perdons du temps... beaucoup de temps !

	bsr	ReceiveByte
	cmp.b	#LINK_BYTE,d0
	beq.s	\Lose
	bsr	Synchro
	bne	Link_Start_Level
\Win:
	addq.w	#1,Score(a6)
	bra	Link_Start_Level
\Lose:
	moveq	#LINK_BYTE,d0
	bsr	SendByte
	addq.w	#1,Score+2(a6)
	bra	Link_Start_Level

; Quit the link mode.
Link_Exit:
	move.l (a7)+,LevelADR(a6)	; restore ADR
	rts


; New Auto-Int4 for Link Service
NewInt4:
	movem.l	d0-d2/a0-a2,-(a7)
	move.l	#$60000C,a1
	move.l	#$60000F,a2
	lea	Buffer_Receive(PC),a0
	move.w	(a1),d2		; Read Link-Status
	btst	#3,d2
	bne.s	Int4_Exit2
	btst	#7,d2
	bne.s	Int4_Sub1
	btst	#5,d2		; One Byte received ?
	beq.s	Int4_NoReceive
	move.w	2(a0),d1	; OffSet of Buffer
	move.b	(a2),4(a0,d1.w)	; Get the byte and save it in the buffer
	addq.w	#1,d1		; Next OffSet
	cmp.w	#MAX_LINK_BUFFER,d1
	blt.s	\NoClear
	clr.w	d1		; Retour au dbut
	st	(a0)		; All has been received !
\NoClear:
	move.w	d1,2(a0)		; Save the OffSet
	bra.s	Int4_Exit2
Int4_NoReceive:
	move.w	(a1),d2		; ReFresh Link-Statut
	btst	#9,d2
	beq.s	Int4_Exit2
Int4_Send:
	lea	Buffer_Send(PC),a0
	tst.w	(a0)		; Something to send ?
	beq.s	Int4_Exit1
	move.w	(a1),d2		; ReFresh Link-Statut
	btst	#6,d2		; Transmit-Buffer is empty ?
	beq.s	Int4_Exit2	; No quit
	move.w	2(a0),d1	; OffSet
	move.b	4(a0,d1.w),d0	; Get the byte to send
\Sub_Loop:
	move.w	(a1),d2		; ReFresh Link-Statut
	btst	#7,d2
	bne.s	Int4_Sub1
	btst	#6,d2
	beq.s	\Sub_Loop
	move.b	d0,(a2)		; Write the byte in the Write-link-Buffer
	addq.w	#1,d1		; Next OffSet
	cmp.w	#MAX_LINK_BUFFER,d1
	blt.s	\NoClear
	clr.w	d1		; Retour au dbut
	clr.w	(a0)		; All has been sent : BufferS.w = 0
\NoClear:
	move.w	d1,2(a0)	; Save the OffSet
	bra.s	Int4_Send
Int4_Exit1:
	bclr.b	#1,$60000C	; Disable send-call
Int4_Exit2:
	movem.l	(a7)+,d0-d2/a0-a2
NewInt5:
NewInt6:
	rte
Int4_Sub1:
	move.b	#$E0,$60000C	; Set Bit 7, 6 ,5
	move.b	#$8D,$60000C	; Set Bit 0, 2, 3 & 7
	bra.s	Int4_Exit2

; These 3 functions need than int 4 of Ti-OS
; works perfectly !

SendByte:
 movem.l d0-d1/a0-a2,-(a7)
 lea	(BufferR+4)(a6),a2
 move.b	d0,(a2)
 move.w	#1,-(a7)
 move.l a2,-(a7)
 jsr	tios::transmit
 addq.l	#6,a7
 movem.l (a7)+,d0-d1/a0-a2
 rts

ReceiveByte:
 movem.l d1/a0-a2,-(a7)
 lea	(BufferR+4)(a6),a2
 clr.b	(a2)
 move.w	#1,-(a7)
 move.l a2,-(a7)
 jsr	tios::receive
 addq.l	#6,a7
 move.b	(a2),d0
 movem.l (a7)+,d1/a0-a2
 rts

; Synchronisation between two calcs.
; Support ESC key if int 1 enable.
; Return : d0 = 1 => ESC pressed, = 0 else.
Synchro:
 move.b	#LINK_BYTE,d0
 bsr	SendByte
\WaitReply:
 clr.w	tios::kb_vars+$1c
 bsr	ReceiveByte
 cmp.b	#LINK_BYTE,d0
 beq.s	\SynchDone
 cmp.w	#264,tios::kb_vars+$1e
 bne.s	\WaitReply
 moveq	#1,d0	; Pas ok !
 rts
\SynchDone:
 moveq	#LINK_BYTE,d0
 bsr	SendByte
\l1:
 moveq	#-1,d0
\l2:
 dbf	d0,\l2	; Perdons du temps...
 moveq	#0,d0	; Ok !
 rts


